
#pragma once

/*****************************************************************************/
/*                              Legal                                        */
/*****************************************************************************/

/*
** Copyright 2015-2018. Lantronix, Inc. All Rights Reserved.
** By using this software, you are agreeing to the terms of the Software
** Development Kit (SDK) License Agreement included in the distribution package
** for this software (the License Agreement).
** Under the License Agreement, this software may be used solely to create
** custom applications for use on the Lantronix xPico Wi-Fi product.
** THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION IS PROVIDED "AS IS".
** LANTRONIX SPECIFICALLY DISCLAIMS ANY WARRANTIES, INCLUDING, BUT NOT LIMITED
** TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY, NON-INFRINGEMENT AND FITNESS
** FOR A PARTICULAR PURPOSE.
** LANTRONIX HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
** ENHANCEMENTS, OR MODIFICATIONS TO THIS SOFTWARE.
** IN NO EVENT SHALL LANTRONIX BE LIABLE TO ANY PARTY FOR DIRECT, INDIRECT,
** SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES, INCLUDING LOST PROFITS,
** ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF
** LANTRONIX HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

/*****************************************************************************/
/*                             Includes                                      */
/*****************************************************************************/

#include "ltrx_definitions.h"

/*****************************************************************************/
/*                             Structs                                       */
/*****************************************************************************/

struct ltrx_http_client;

struct ltrx_http_ajax
{
    const char *registerName;
    bool (*callback)(struct ltrx_http_client *pClient);
};

struct ltrx_http_dynamic_callback
{
    const char *uriPath;
    bool (*callback)(struct ltrx_http_client *client);
    const char *helpText;
};

/*****************************************************************************/
/*                            Prototypes                                     */
/*****************************************************************************/

void ltrx_ajax_end_response(
    struct ltrx_http_client *client
);

void ltrx_ajax_register(
    const struct ltrx_http_ajax *ajaxDef
);

void ltrx_ajax_send_xml_end(
    struct ltrx_http_client *client
);

void ltrx_ajax_send_xml_node_encoded(
    struct ltrx_http_client *pClient,
    const char *pTarget,
    const char *pData
);

void ltrx_ajax_send_xml_node_end(
    struct ltrx_http_client *client,
    const char *target
);

void ltrx_ajax_send_xml_node_start(
    struct ltrx_http_client *client,
    const char *target
);

void ltrx_ajax_send_xml_node_unsigned(
    struct ltrx_http_client *client,
    const char *target,
    uint32_t value
);

void ltrx_ajax_send_xml_start(
    struct ltrx_http_client *client,
    const char *target,
    const char *attribute
);

void ltrx_ajax_start_response(
    struct ltrx_http_client *client
);

void ltrx_http_dynamic_callback_register(
    const struct ltrx_http_dynamic_callback *hdc
);

const char *ltrx_http_get_request_path(
    const struct ltrx_http_client *client
);

const char *ltrx_http_get_request_query_data(
    const struct ltrx_http_client *client
);

struct ltrx_ip_socket *ltrx_http_get_socket(
    const struct ltrx_http_client *client
);

void ltrx_http_send_data_encoded(
    struct ltrx_http_client *client,
    const char *data
);

void ltrx_webmgr_init_js_register(
    const char *javascriptFilename
);
