SECTIONS
{
    .text :
    {
        *(.module_info*)
        *(.text .text.* .gnu.linkonce.t.*)
        *(.rodata .rodata.* .gnu.linkonce.r.*)
        . = ALIGN(8);
    }=0xffffffff

    .data : AT( ADDR(.text) + SIZEOF(.text) )
    {
        _data_start = .;
        *(.data*)
        . = ALIGN(8);
        _data_end = .;
    }=0xffffffff

    .bss :
    {
        . = _data_end;
        _bss_start = .;
        *(.bss*)
        *(COMMON)
        . = ALIGN(8);
        _bss_end = .;
    }

    .ARM.attributes :
    {
        *(.ARM.attributes*)
    }

    .comment :
    {
        *(.comment*)
    }

    /DISCARD/ :
    {
        *(.init)
        *(.preinit)
        *(.fini)
        *(.fini_array)
        *(.ARM.exidx*)
        *(.gnu.linkonce.armexidx.*)
        *(.eh_frame_hdr)
        *(.eh_frame)
        *(.gnu.linkonce.armextab.*)
        *(.v4_bx)
        *(.vfp11_veneer)
        *(.gcc_except_table)
        *(.eh_frame_hdr)
        *(.eh_frame)
        *(.glue*)
    }
}

/* provide linker symbols */
ltrx_linker_code_size = SIZEOF(.text);
ltrx_linker_data_size = _data_end - _data_start;
ltrx_linker_bss_size = _bss_end - _bss_start;
ltrx_linker_module_flash_end = ADDR(.text) + SIZEOF(.text) + (_data_end - _data_start);
ltrx_linker_module_ram_end = _bss_end;
